diff --git a/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenSleepMP.java b/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenSleepMP.java
index e42b43a56..18a7451d6 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenSleepMP.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenSleepMP.java
@@ -7,6 +7,7 @@ import net.minecraft.core.net.packet.PacketUpdatePlayerState;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.net.ChatEmotes;
 import net.minecraft.core.lang.I18n;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
 
 public class ScreenSleepMP extends ScreenChat
@@ -49,7 +50,7 @@ public class ScreenSleepMP extends ScreenChat
     }
 
     @Override
-	protected void buttonClicked(ButtonElement button)
+	protected void buttonClicked(@NotNull ButtonElement button)
     {
         if(button.id == 1)
         {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
index 1591c2e7c..f0056c498 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
@@ -30,6 +30,7 @@ import net.minecraft.core.player.inventory.menu.*;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.player.inventory.slot.SlotResult;
 import net.minecraft.core.player.inventory.slot.SlotCreative;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
@@ -505,7 +506,7 @@ public abstract class ScreenContainerAbstract extends Screen
 		int[] args = new int[] { slotId, target };
 		mc.playerController.handleInventoryMouseClick(inventorySlots.containerId, action, args, mc.thePlayer);
 	}
-	public void controllerInput(ControllerInput controller){
+	public void controllerInput(@NotNull ControllerInput controller){
 		Slot slot = controller.getSlotAtCursor(this);
 
 //		if(joyLeft.stoppedMoving()) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenCrafting.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenCrafting.java
index a8cd96504..1d2cfe77c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenCrafting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenCrafting.java
@@ -5,6 +5,7 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.menu.MenuCrafting;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 
 public class ScreenCrafting extends ScreenContainerAbstract
@@ -38,7 +39,7 @@ public class ScreenCrafting extends ScreenContainerAbstract
         drawTexturedModalRect(j, k, 0, 0, xSize, ySize);
     }
     @Override
-    public void guiSpecificControllerInput(ControllerInput controller){
+    public void guiSpecificControllerInput(@NotNull ControllerInput controller){
         super.guiSpecificControllerInput(controller);
         controller.inventoryHandler.handleCrafting(this);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
index 910e3dd0b..8ad9ec4ba 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFlagEditor.java
@@ -7,6 +7,7 @@ import net.minecraft.client.gui.DrawableSurfaceElement;
 import net.minecraft.client.gui.TexturedButtonElement;
 import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.entity.player.Player;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
@@ -222,7 +223,7 @@ public class ScreenFlagEditor
     }
 
     @Override
-    protected void buttonClicked(ButtonElement button)
+    protected void buttonClicked(@NotNull ButtonElement button)
     {
         super.buttonClicked(button);
         if (button.id >= 0 && button.id < 7)
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java
index e7c32aa16..da552c1f2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnace.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.entity.TileEntityFurnaceBlast;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.inventory.menu.MenuFurnace;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 
 public class ScreenFurnace extends ScreenContainerAbstract
@@ -42,7 +43,7 @@ public class ScreenFurnace extends ScreenContainerAbstract
         }
     }
     @Override
-    public void guiSpecificControllerInput(ControllerInput controller){
+    public void guiSpecificControllerInput(@NotNull ControllerInput controller){
         super.guiSpecificControllerInput(controller);
         controller.inventoryHandler.handleFurnace(this);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnaceBlast.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnaceBlast.java
index 68a4b9e58..0b856472b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnaceBlast.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenFurnaceBlast.java
@@ -43,7 +43,7 @@ public class ScreenFurnaceBlast
     }
 
     @Override
-    public void guiSpecificControllerInput(final ControllerInput controller) {
+    public void guiSpecificControllerInput(final @NotNull ControllerInput controller) {
         super.guiSpecificControllerInput(controller);
         controller.inventoryHandler.handleFurnaceBlast(this);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
index 7a1aba857..cacf3487d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
@@ -25,6 +25,7 @@ import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.EntityRenderDispatcher;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.core.util.helper.Color;
@@ -300,7 +301,7 @@ public class ScreenInventory extends ScreenContainerAbstract
     }
 
     @Override
-	protected void buttonClicked(ButtonElement button)
+	protected void buttonClicked(@NotNull ButtonElement button)
     {
         if (button == armorButton) {
         	mc.gameSettings.armorProtectionOverlay.toggle();
@@ -308,7 +309,7 @@ public class ScreenInventory extends ScreenContainerAbstract
     }
 
     @Override
-    public void guiSpecificControllerInput(ControllerInput controller){
+    public void guiSpecificControllerInput(@NotNull ControllerInput controller){
         super.guiSpecificControllerInput(controller);
         controller.inventoryHandler.handleInventory(this);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
index 72742b02f..85daf0176 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventoryCreative.java
@@ -12,6 +12,7 @@ import net.minecraft.core.player.inventory.menu.MenuInventoryCreative;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.EntityRenderDispatcher;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
@@ -97,7 +98,7 @@ public class ScreenInventoryCreative extends ScreenInventory implements ITextCha
 	}
 	
     @Override
-	protected void buttonClicked(ButtonElement button)
+	protected void buttonClicked(@NotNull ButtonElement button)
     {
 		super.buttonClicked(button);
     	if (!button.enabled)
@@ -232,7 +233,7 @@ public class ScreenInventoryCreative extends ScreenInventory implements ITextCha
 		updatePageSwitcher();
 	}
 	@Override
-	public void guiSpecificControllerInput(ControllerInput controller){
+	public void guiSpecificControllerInput(@NotNull ControllerInput controller){
 		if(controller.buttonLeftShoulder.pressedThisFrame()) {
 			this.scroll(1);
 		}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/error/ScreenBadJavaArch.java b/game/client/src/main/java/net/minecraft/client/gui/error/ScreenBadJavaArch.java
index 1ca47a171..85322c11c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/error/ScreenBadJavaArch.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/error/ScreenBadJavaArch.java
@@ -7,6 +7,7 @@ import net.minecraft.client.gui.ScreenMainMenu;
 import net.minecraft.client.util.helper.UrlHelper;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
 
 public class ScreenBadJavaArch extends Screen
 {
@@ -25,7 +26,7 @@ public class ScreenBadJavaArch extends Screen
     }
 
     @Override
-	protected void buttonClicked(ButtonElement button)
+	protected void buttonClicked(@NotNull ButtonElement button)
     {
         if(!button.enabled)
         {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/error/ScreenConflictWarning.java b/game/client/src/main/java/net/minecraft/client/gui/error/ScreenConflictWarning.java
index 9dc92c1b4..cda86fd8e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/error/ScreenConflictWarning.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/error/ScreenConflictWarning.java
@@ -4,6 +4,7 @@ import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.ScreenMainMenu;
 import net.minecraft.core.lang.I18n;
+import org.jetbrains.annotations.NotNull;
 
 public class ScreenConflictWarning extends Screen
 {
@@ -20,7 +21,7 @@ public class ScreenConflictWarning extends Screen
     }
 
     @Override
-	protected void buttonClicked(ButtonElement button)
+	protected void buttonClicked(@NotNull ButtonElement button)
     {
         if(!button.enabled)
         {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/error/ScreenMissingJCE.java b/game/client/src/main/java/net/minecraft/client/gui/error/ScreenMissingJCE.java
index 20d0cf8a2..970abab8c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/error/ScreenMissingJCE.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/error/ScreenMissingJCE.java
@@ -49,7 +49,7 @@ public class ScreenMissingJCE extends Screen {
     }
 
     @Override
-    protected void buttonClicked(final ButtonElement button)
+    protected void buttonClicked(final @NotNull ButtonElement button)
     {
         if(!button.enabled)
         {
@@ -73,7 +73,7 @@ public class ScreenMissingJCE extends Screen {
     }
 
     @Override
-    protected void buttonReleased(ButtonElement button) {
+    protected void buttonReleased(@NotNull ButtonElement button) {
         if (button.id == 1) {
             this.continueHeld = false;
             this.clickStart = 0;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/error/ScreenMissingMinecraft.java b/game/client/src/main/java/net/minecraft/client/gui/error/ScreenMissingMinecraft.java
index 6ecf5780e..cd0b82495 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/error/ScreenMissingMinecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/error/ScreenMissingMinecraft.java
@@ -8,6 +8,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.util.helper.UrlHelper;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 import org.slf4j.Logger;
 
@@ -42,7 +43,7 @@ public class ScreenMissingMinecraft extends Screen {
         super.render(mx, my, partialTick);
     }
     @Override
-    protected void buttonClicked(ButtonElement button)
+    protected void buttonClicked(@NotNull ButtonElement button)
     {
         if(!button.enabled)
         {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
index eaf4fcf2f..b617c7e2c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
@@ -19,6 +19,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
@@ -318,7 +319,7 @@ public class ScreenGuidebook
         mc.sndManager.playSound("random.page", SoundCategory.GUI_SOUNDS, 0.8f, 0.9f + (r.nextFloat() - r.nextFloat()) * 0.1f);
     }
 
-    public void guiSpecificControllerInput(ControllerInput controller){
+    public void guiSpecificControllerInput(@NotNull ControllerInput controller){
         super.guiSpecificControllerInput(controller);
         if (controller.digitalPad.left.pressedThisFrame() || (controller.digitalPad.left.isPressed() && controller.digitalPad.left.getHoldTime() % 4 == 0)){
             guidebookPageManager.offsetPage(-2);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/ScreenKeyboard.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/ScreenKeyboard.java
index 7001f0262..982ac2a5b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/keyboard/ScreenKeyboard.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/ScreenKeyboard.java
@@ -247,7 +247,7 @@ public class ScreenKeyboard extends Screen implements ITextField {
     }
 
     @Override
-    public void guiSpecificControllerInput(ControllerInput controller) {
+    public void guiSpecificControllerInput(@NotNull ControllerInput controller) {
         int keyboardWidth = keyboardLayout.getWidth();
         int keyboardHeight = keyboardLayout.getHeight();
 
@@ -356,7 +356,7 @@ public class ScreenKeyboard extends Screen implements ITextField {
     }
 
     @Override
-    public void playControllerButtonSound(ControllerInput controller) {
+    public void playControllerButtonSound(@NotNull ControllerInput controller) {
         if (controller.buttonStart.pressedThisFrame()) {
             mc.sndManager.playSound("ui.ui_click", SoundCategory.GUI_SOUNDS, 1.0f, 1.0f);
         }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
index dea91a594..fc583f7aa 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
@@ -462,7 +462,7 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
 //        mc.theWorld.getLevelData().setWorldTime(mc.theWorld.getWorldTime() + 1);
     }
     @Override
-    protected void buttonClicked(ButtonElement button) {
+    protected void buttonClicked(@NotNull ButtonElement button) {
         // Overrides the regular GuiPhotomode's method
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
index aac134037..6f64a7b56 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/ScreenOptions.java
@@ -157,7 +157,7 @@ public class ScreenOptions
     }
 
     @Override
-    protected void buttonClicked(ButtonElement button) {
+    protected void buttonClicked(@NotNull ButtonElement button) {
         super.buttonClicked(button);
 
         if (button.id == 0)
@@ -581,7 +581,7 @@ public class ScreenOptions
     }
 
     @Override
-    public void guiSpecificControllerInput(ControllerInput controller) {
+    public void guiSpecificControllerInput(@NotNull ControllerInput controller) {
         if(controller.buttonStart.pressedThisFrame()) {
             this.keyPressed((char)0, Keyboard.KEY_ESCAPE, -1, -1);
         }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
index 64ef2a28c..dc0a9653e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
@@ -11,6 +11,8 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
 import org.jetbrains.annotations.Nullable;
 
+import java.util.Objects;
+
 public class DifficultyOptionComponent extends ButtonComponent {
 
     protected final OptionEnum<Difficulty> option;
@@ -36,7 +38,7 @@ public class DifficultyOptionComponent extends ButtonComponent {
         onChanged();
         this.option.onUpdate();
         if (mc.currentWorld != null && this.lockButton.mouseClicked(mc, this.slider.xPosition + relativeMouseX, this.slider.yPosition + relativeMouseY)) {
-            mc.displayScreen(new PopupBuilder(mc.currentScreen, 160)
+            mc.displayScreen(new PopupBuilder(Objects.requireNonNull(mc.currentScreen), 160)
                     .withLabel("gui.options.difficultylock.warning.1")
                     .withLabel("gui.options.difficultylock.warning.2")
                     .withLabel("gui.options.difficultylock.warning.3", 0xFF0000)
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 6e8836a25..5ada75d6f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -337,6 +337,7 @@ public abstract class OptionsPages
             )
             .withComponent(new OptionsCategory("gui.options.page.debug.category.settings")
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.developerMode))
+                .withComponent(new BooleanOptionComponent(mc.gameSettings.viewSupportMode))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.alphaMenu))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.lockCamera))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.showDebugScreen))
diff --git a/game/client/src/main/java/net/minecraft/client/gui/paged/Page.java b/game/client/src/main/java/net/minecraft/client/gui/paged/Page.java
index e71ae27e4..a22b93b82 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/paged/Page.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/paged/Page.java
@@ -2,56 +2,51 @@ package net.minecraft.client.gui.paged;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.ArrayList;
 import java.util.List;
 
 public class Page {
     private static final int COMPONENT_SPACING = 4;
-    private final String translationKey;
-    private final List<PageComponent> components = new ArrayList<>();
-    private final ItemStack icon;
+    private final @NotNull String translationKey;
+    private final @NotNull List<@NotNull PageComponent> components = new ArrayList<>();
+    private final @NotNull ItemStack icon;
 
-    public Page(String translationKey, ItemStack icon) {
+    public Page(final @NotNull String translationKey, final @NotNull ItemStack icon) {
         this.translationKey = translationKey;
         this.icon = icon;
     }
 
-    public Page withComponent(PageComponent component)
-    {
-        components.add(component);
+    public @NotNull Page withComponent(final @NotNull PageComponent component) {
+        this.components.add(component);
         return this;
     }
 
-    public String getTranslationKey()
-    {
-        return translationKey;
+    public @NotNull String getTranslationKey() {
+        return this.translationKey;
     }
 
-    public List<PageComponent> getComponents()
-    {
-        return components;
+    public @NotNull List<@NotNull PageComponent> getComponents() {
+        return this.components;
     }
 
-    public void initComponents(Minecraft mc) {
-        for (PageComponent component : components) {
+    public void initComponents(final @NotNull Minecraft mc) {
+        for (final @NotNull PageComponent component : this.components) {
             component.init(mc);
         }
     }
 
-    public int getHeight()
-    {
+    public int getHeight() {
         int height = 0;
-        for (PageComponent component : components)
-        {
+        for (final @NotNull PageComponent component : this.components) {
             height += component.getHeight() + COMPONENT_SPACING;
         }
         height -= COMPONENT_SPACING;
         return height;
     }
 
-    public ItemStack getIcon()
-    {
-        return icon;
+    public @NotNull  ItemStack getIcon() {
+        return this.icon;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/paged/PageRegistry.java b/game/client/src/main/java/net/minecraft/client/gui/paged/PageRegistry.java
index 5ce0ad5c7..22a9c4094 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/paged/PageRegistry.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/paged/PageRegistry.java
@@ -1,25 +1,27 @@
 package net.minecraft.client.gui.paged;
 
+import org.jetbrains.annotations.NotNull;
+
 import java.util.ArrayList;
 import java.util.Collections;
 import java.util.List;
 
 public class PageRegistry {
-    private final List<Page> pages = new ArrayList<>();
+    private final @NotNull List<@NotNull Page> pages = new ArrayList<>();
 
-    public Page register(Page page) {
-        if (!pages.contains(page)) {
-            pages.add(page);
+    public @NotNull Page register(final @NotNull Page page) {
+        if (!this.pages.contains(page)) {
+            this.pages.add(page);
         }
 
         return page;
     }
 
-    public int getPageIndex(Page page) {
-        return pages.indexOf(page);
+    public int getPageIndex(final @NotNull Page page) {
+        return this.pages.indexOf(page);
     }
 
-    public List<Page> getPages() {
-        return Collections.unmodifiableList(pages);
+    public @NotNull List<@NotNull Page> getPages() {
+        return Collections.unmodifiableList(this.pages);
     }
 }
